package cn.com.qmth.examcloud.starters.face.verify.service;

import cn.com.qmth.examcloud.starters.face.verify.common.FaceResult;

import java.io.File;

public interface FaceVerifyService {

    /**
     * 百度 人脸活体检测
     */
    FaceResult faceVerifyByBaidu(String imageUrl);

    /**
     * 百度 人脸活体检测
     */
    FaceResult faceVerifyByBaidu(File imageFile);

    /**
     * 百度 人脸检测
     */
    FaceResult faceDetectByBaidu(String imageUrl);

    /**
     * 百度 人脸检测
     */
    FaceResult faceDetectByBaidu(File imageFile);

    /**
     * 百度 人脸比对
     */
    FaceResult faceCompareByBaidu(String imageUrl, String imageUrl2);

    /**
     * 百度 人脸比对
     */
    FaceResult faceCompareByBaidu(File imageFile, File imageFile2);

    /**
     * Face++ 人脸检测
     */
    FaceResult faceDetectByFacePlus(String imageUrl);

    /**
     * Face++ 人脸检测
     */
    FaceResult faceDetectByFacePlus(File imageFile);

    /**
     * Face++ 人脸比对
     */
    FaceResult faceCompareByFacePlus(String imageUrl, String imageUrl2);

    /**
     * Face++ 人脸比对
     */
    FaceResult faceCompareByFacePlus(File imageFile, File imageFile2);

}
