package cn.com.qmth.examcloud.starters.face.verify.test;

import cn.com.qmth.examcloud.starters.face.verify.FaceVerifyProperties;
import cn.com.qmth.examcloud.starters.face.verify.common.FaceResult;
import cn.com.qmth.examcloud.starters.face.verify.common.JsonHelper;
import cn.com.qmth.examcloud.starters.face.verify.service.impl.FaceVerifyServiceImpl;
import org.junit.Test;

import java.io.File;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class FaceVerifyTest {

    @Test
    public void demo() throws Exception {
        FaceVerifyProperties properties = new FaceVerifyProperties();
        properties.setFacePlusKey("xxx");
        properties.setFacePlusSecret("xxx");
        properties.setBaiduKey("xxx");
        properties.setBaiduSecret("xxx");
        properties.setBaiduLocalEnabled(true);
        properties.setBaiduLocalAppId("test");
        properties.setBaiduLocalUrlPrefix("http://192.168.10.102:8301");

        FaceVerifyServiceImpl faceVerifyService = new FaceVerifyServiceImpl();
        faceVerifyService.setProperties(properties);

        // String imageUrl = "https://img0.baidu.com/it/u=2750657437,2761718651&fm=253&fmt=auto&app=138&f=JPEG?w=500&h=749";
        // String imageUrl = "https://img2.baidu.com/it/u=1657567997,3247312681&fm=253&fmt=auto&app=138&f=JPEG?w=500&h=666";
        String imageUrl = "https://img0.baidu.com/it/u=3045244088,3053373141&fm=253&fmt=auto&app=138&f=JPEG?w=200&h=200";
        String imageUrl2 = "https://img2.baidu.com/it/u=529672263,3841026141&fm=253&fmt=auto&app=138&f=JPEG?w=200&h=200";

        File imageFile1 = new File("D:\\home\\test\\101.jpg");
        File imageFile2 = new File("D:\\home\\test\\102.jpg");

        // FaceResult result = faceVerifyService.faceVerifyByBaidu(imageUrl);
        FaceResult result = faceVerifyService.faceVerifyByBaidu(imageFile1);
        // FaceResult result = faceVerifyService.faceDetectByBaidu(imageUrl);
        // FaceResult result = faceVerifyService.faceDetectByBaidu(imageFile1);
        // FaceResult result = faceVerifyService.faceCompareByBaidu(imageUrl, imageUrl2);
        // FaceResult result = faceVerifyService.faceCompareByBaidu(imageFile1, imageFile2);
        // FaceResult result = faceVerifyService.faceDetectByFacePlus(imageUrl);
        // FaceResult result = faceVerifyService.faceDetectByFacePlus(imageFile1);
        // FaceResult result = faceVerifyService.faceCompareByFacePlus(imageUrl, imageUrl2);
        // FaceResult result = faceVerifyService.faceCompareByFacePlus(imageFile1, imageFile2);
        System.out.println("==================================================");
        System.out.println(new JsonHelper().toJson(result));

        // concurrentTest(faceVerifyService, imageUrl, imageFile1);
    }

    private void concurrentTest(FaceVerifyServiceImpl faceVerifyService, String imageUrl, File imageFile) {
        int threadNum = 20;
        ExecutorService service = Executors.newCachedThreadPool();
        final CountDownLatch commander = new CountDownLatch(1);
        final CountDownLatch worker = new CountDownLatch(threadNum);

        for (int n = 0; n < threadNum; n++) {
            Runnable runnable = () -> {
                try {
                    FaceResult res = faceVerifyService.faceVerifyByBaidu(imageFile);
                    System.out.println("线程：" + Thread.currentThread().getName() + " 结果：" + new JsonHelper().toJson(res) + "\n");
                } catch (Exception e) {
                    e.printStackTrace();
                } finally {
                    worker.countDown();
                }
            };
            service.execute(runnable);
        }

        try {
            commander.countDown();
            worker.await();
        } catch (Exception e) {
            e.printStackTrace();
        }

        service.shutdown();
    }

}
